Subject: Bonding in active-backup mode with arp monitoring on Xen

From: Tsutomu Fujii <[email-masked]>
Date: Thu, 27 Mar 2008 21:49:04 +0900

Hi.

A little while ago I posted a patch to fix the communication problem
when bonding was used in active-backup mode with arp monitoring on Xen
guest OS.

http://marc.info/?l=linux-netdev&m=119362063924723&w=2

I have rebased the patch to the latest 2.6.25-rc7 kernel.

I've confirmed that active-backup mode works fine with arp monitoring
with this patch.

Thanks.

--
Tsutomu fujii

--- a/drivers/net/bonding/bond_main.c	2008-03-26 10:38:14.000000000 +0900
+++ b/drivers/net/bonding/bond_main.c	2008-03-27 19:39:06.000000000 +0900
@@ -3003,7 +3003,7 @@
 		/* the current slave must tx an arp to ensure backup slaves
 		 * rx traffic
 		 */
-		if (slave && bond_has_ip(bond)) {
+		if (slave && IS_UP(slave->dev)) {
 			bond_arp_send_all(bond, slave);
 		}
 	}